/* ContractMatcher.c generated by valac 0.34.4, the Vala compiler
 * generated from ContractMatcher.vala, do not modify */

/*
 * Copyright (C) 2011-2013 elementary Developers
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define CONTRACTOR_TYPE_CONTRACT (contractor_contract_get_type ())
#define CONTRACTOR_CONTRACT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTRACTOR_TYPE_CONTRACT, ContractorContract))
#define CONTRACTOR_CONTRACT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTRACTOR_TYPE_CONTRACT, ContractorContractClass))
#define CONTRACTOR_IS_CONTRACT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTRACTOR_TYPE_CONTRACT))
#define CONTRACTOR_IS_CONTRACT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTRACTOR_TYPE_CONTRACT))
#define CONTRACTOR_CONTRACT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTRACTOR_TYPE_CONTRACT, ContractorContractClass))

typedef struct _ContractorContract ContractorContract;
typedef struct _ContractorContractClass ContractorContractClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	CONTRACTOR_CONTRACTOR_ERROR_NO_MIMETYPES_GIVEN
} ContractorContractorError;
#define CONTRACTOR_CONTRACTOR_ERROR contractor_contractor_error_quark ()


GType contractor_contract_get_type (void) G_GNUC_CONST;
GQuark contractor_contractor_error_quark (void);
GeeCollection* contractor_contract_matcher_get_contracts_for_types (gchar** mime_types, int mime_types_length1, GeeCollection* contracts_to_filter, GError** error);
gchar** contractor_string_clean_array (gchar** str_array, int str_array_length1, int* result_length1);
gboolean contractor_contract_supports_mime_type (ContractorContract* self, const gchar* mime_type);
GeeCollection* contractor_contract_matcher_get_contracts_for_file_size (gint64 file_size, GeeCollection* contracts_to_filter, GError** error);
gboolean contractor_contract_supports_file_size (ContractorContract* self, gint64 file_size);
GeeCollection* contractor_contract_matcher_get_contracts_for_types_and_file_size (gchar** mime_types, int mime_types_length1, gint64 file_size, GeeCollection* contracts_to_filter, GError** error);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


/**
     * get contracts which support the passed MIME types
     *
     * @param mime_types the MIME types which have to be supported by the returned contracts
     * @param contracts_to_filter a list of contracts to filter
     *
     * @return a Collection of Contract objects which support the file size
     */
GeeCollection* contractor_contract_matcher_get_contracts_for_types (gchar** mime_types, int mime_types_length1, GeeCollection* contracts_to_filter, GError** error) {
	GeeCollection* result = NULL;
	GeeLinkedList* valid_contracts = NULL;
	GeeLinkedList* _tmp0_ = NULL;
	gchar** valid_mime_types = NULL;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	gint _tmp2_ = 0;
	gchar** _tmp3_ = NULL;
	gint valid_mime_types_length1 = 0;
	gint _valid_mime_types_size_ = 0;
	gchar** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	GError * _inner_error_ = NULL;
#line 27 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	g_return_val_if_fail (contracts_to_filter != NULL, NULL);
#line 30 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	_tmp0_ = gee_linked_list_new (CONTRACTOR_TYPE_CONTRACT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 30 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	valid_contracts = _tmp0_;
#line 31 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	_tmp1_ = mime_types;
#line 31 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	_tmp1__length1 = mime_types_length1;
#line 31 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	_tmp3_ = contractor_string_clean_array (_tmp1_, _tmp1__length1, &_tmp2_);
#line 31 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	valid_mime_types = _tmp3_;
#line 31 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	valid_mime_types_length1 = _tmp2_;
#line 31 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	_valid_mime_types_size_ = valid_mime_types_length1;
#line 33 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	_tmp4_ = valid_mime_types;
#line 33 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	_tmp4__length1 = valid_mime_types_length1;
#line 33 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	if (_tmp4__length1 == 0) {
#line 105 "ContractMatcher.c"
		GError* _tmp5_ = NULL;
#line 34 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
		_tmp5_ = g_error_new_literal (CONTRACTOR_CONTRACTOR_ERROR, CONTRACTOR_CONTRACTOR_ERROR_NO_MIMETYPES_GIVEN, "No mimetypes were provided.");
#line 34 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
		_inner_error_ = _tmp5_;
#line 34 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
		if (_inner_error_->domain == CONTRACTOR_CONTRACTOR_ERROR) {
#line 34 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			g_propagate_error (error, _inner_error_);
#line 34 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			valid_mime_types = (_vala_array_free (valid_mime_types, valid_mime_types_length1, (GDestroyNotify) g_free), NULL);
#line 34 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_g_object_unref0 (valid_contracts);
#line 34 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			return NULL;
#line 121 "ContractMatcher.c"
		} else {
#line 34 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			valid_mime_types = (_vala_array_free (valid_mime_types, valid_mime_types_length1, (GDestroyNotify) g_free), NULL);
#line 34 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_g_object_unref0 (valid_contracts);
#line 34 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 34 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			g_clear_error (&_inner_error_);
#line 34 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			return NULL;
#line 133 "ContractMatcher.c"
		}
	}
	{
		GeeIterator* _contract_it = NULL;
		GeeCollection* _tmp6_ = NULL;
		GeeIterator* _tmp7_ = NULL;
#line 37 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
		_tmp6_ = contracts_to_filter;
#line 37 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
#line 37 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
		_contract_it = _tmp7_;
#line 37 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
		while (TRUE) {
#line 148 "ContractMatcher.c"
			GeeIterator* _tmp8_ = NULL;
			gboolean _tmp9_ = FALSE;
			ContractorContract* contract = NULL;
			GeeIterator* _tmp10_ = NULL;
			gpointer _tmp11_ = NULL;
			gboolean all_types_supported = FALSE;
			gchar** _tmp12_ = NULL;
			gint _tmp12__length1 = 0;
			gboolean _tmp17_ = FALSE;
#line 37 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_tmp8_ = _contract_it;
#line 37 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_tmp9_ = gee_iterator_next (_tmp8_);
#line 37 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			if (!_tmp9_) {
#line 37 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
				break;
#line 166 "ContractMatcher.c"
			}
#line 37 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_tmp10_ = _contract_it;
#line 37 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 37 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			contract = (ContractorContract*) _tmp11_;
#line 39 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			all_types_supported = TRUE;
#line 41 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_tmp12_ = valid_mime_types;
#line 41 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_tmp12__length1 = valid_mime_types_length1;
#line 180 "ContractMatcher.c"
			{
				gchar** mime_type_collection = NULL;
				gint mime_type_collection_length1 = 0;
				gint _mime_type_collection_size_ = 0;
				gint mime_type_it = 0;
#line 41 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
				mime_type_collection = _tmp12_;
#line 41 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
				mime_type_collection_length1 = _tmp12__length1;
#line 41 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
				for (mime_type_it = 0; mime_type_it < _tmp12__length1; mime_type_it = mime_type_it + 1) {
#line 192 "ContractMatcher.c"
					gchar* _tmp13_ = NULL;
					gchar* mime_type = NULL;
#line 41 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
					_tmp13_ = g_strdup (mime_type_collection[mime_type_it]);
#line 41 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
					mime_type = _tmp13_;
#line 199 "ContractMatcher.c"
					{
						ContractorContract* _tmp14_ = NULL;
						const gchar* _tmp15_ = NULL;
						gboolean _tmp16_ = FALSE;
#line 42 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
						_tmp14_ = contract;
#line 42 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
						_tmp15_ = mime_type;
#line 42 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
						_tmp16_ = contractor_contract_supports_mime_type (_tmp14_, _tmp15_);
#line 42 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
						if (!_tmp16_) {
#line 43 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
							all_types_supported = FALSE;
#line 44 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
							_g_free0 (mime_type);
#line 44 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
							break;
#line 218 "ContractMatcher.c"
						}
#line 41 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
						_g_free0 (mime_type);
#line 222 "ContractMatcher.c"
					}
				}
			}
#line 48 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_tmp17_ = all_types_supported;
#line 48 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			if (_tmp17_) {
#line 230 "ContractMatcher.c"
				GeeLinkedList* _tmp18_ = NULL;
				ContractorContract* _tmp19_ = NULL;
#line 49 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
				_tmp18_ = valid_contracts;
#line 49 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
				_tmp19_ = contract;
#line 49 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
#line 239 "ContractMatcher.c"
			}
#line 37 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_g_object_unref0 (contract);
#line 243 "ContractMatcher.c"
		}
#line 37 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
		_g_object_unref0 (_contract_it);
#line 247 "ContractMatcher.c"
	}
#line 53 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	result = (GeeCollection*) valid_contracts;
#line 53 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	valid_mime_types = (_vala_array_free (valid_mime_types, valid_mime_types_length1, (GDestroyNotify) g_free), NULL);
#line 53 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	return result;
#line 255 "ContractMatcher.c"
}


/**
     * get contracts which support the passed file size
     *
     * @param file_size the file size which has to be supported by the returned contracts
     * @param contracts_to_filter a list of contracts to filter
     *
     * @return a Collection of Contract objects which support the file size
     */
GeeCollection* contractor_contract_matcher_get_contracts_for_file_size (gint64 file_size, GeeCollection* contracts_to_filter, GError** error) {
	GeeCollection* result = NULL;
	GeeLinkedList* valid_contracts = NULL;
	GeeLinkedList* _tmp0_ = NULL;
#line 64 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	g_return_val_if_fail (contracts_to_filter != NULL, NULL);
#line 67 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	_tmp0_ = gee_linked_list_new (CONTRACTOR_TYPE_CONTRACT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 67 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	valid_contracts = _tmp0_;
#line 277 "ContractMatcher.c"
	{
		GeeIterator* _contract_it = NULL;
		GeeCollection* _tmp1_ = NULL;
		GeeIterator* _tmp2_ = NULL;
#line 69 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
		_tmp1_ = contracts_to_filter;
#line 69 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 69 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
		_contract_it = _tmp2_;
#line 69 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
		while (TRUE) {
#line 290 "ContractMatcher.c"
			GeeIterator* _tmp3_ = NULL;
			gboolean _tmp4_ = FALSE;
			ContractorContract* contract = NULL;
			GeeIterator* _tmp5_ = NULL;
			gpointer _tmp6_ = NULL;
			gboolean file_size_supported = FALSE;
			ContractorContract* _tmp7_ = NULL;
			gint64 _tmp8_ = 0LL;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
#line 69 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_tmp3_ = _contract_it;
#line 69 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 69 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			if (!_tmp4_) {
#line 69 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
				break;
#line 309 "ContractMatcher.c"
			}
#line 69 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_tmp5_ = _contract_it;
#line 69 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 69 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			contract = (ContractorContract*) _tmp6_;
#line 70 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			file_size_supported = TRUE;
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_tmp7_ = contract;
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_tmp8_ = file_size;
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_tmp9_ = contractor_contract_supports_file_size (_tmp7_, _tmp8_);
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			if (!_tmp9_) {
#line 73 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
				file_size_supported = FALSE;
#line 329 "ContractMatcher.c"
			}
#line 76 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_tmp10_ = file_size_supported;
#line 76 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			if (_tmp10_) {
#line 335 "ContractMatcher.c"
				GeeLinkedList* _tmp11_ = NULL;
				ContractorContract* _tmp12_ = NULL;
#line 77 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
				_tmp11_ = valid_contracts;
#line 77 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
				_tmp12_ = contract;
#line 77 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 344 "ContractMatcher.c"
			}
#line 69 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_g_object_unref0 (contract);
#line 348 "ContractMatcher.c"
		}
#line 69 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
		_g_object_unref0 (_contract_it);
#line 352 "ContractMatcher.c"
	}
#line 80 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	result = (GeeCollection*) valid_contracts;
#line 80 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	return result;
#line 358 "ContractMatcher.c"
}


/**
     * get contracts which support the passed MIME types and file size
     *
     * @param mime_types the MIME types which have to be supported by the returned contracts
     * @param file_size the file size which has to be supported by the returned contracts
     * @param contracts_to_filter a list of contracts to filter
     *
     * @return a Collection of Contract objects which support the MIME types and the file size
     */
GeeCollection* contractor_contract_matcher_get_contracts_for_types_and_file_size (gchar** mime_types, int mime_types_length1, gint64 file_size, GeeCollection* contracts_to_filter, GError** error) {
	GeeCollection* result = NULL;
	GeeCollection* contracts_for_types = NULL;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	GeeCollection* _tmp1_ = NULL;
	GeeCollection* _tmp2_ = NULL;
	GeeCollection* valid_contracts = NULL;
	gint64 _tmp3_ = 0LL;
	GeeCollection* _tmp4_ = NULL;
	GeeCollection* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
#line 92 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	g_return_val_if_fail (contracts_to_filter != NULL, NULL);
#line 95 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	_tmp0_ = mime_types;
#line 95 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	_tmp0__length1 = mime_types_length1;
#line 95 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	_tmp1_ = contracts_to_filter;
#line 95 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	_tmp2_ = contractor_contract_matcher_get_contracts_for_types (_tmp0_, _tmp0__length1, _tmp1_, &_inner_error_);
#line 95 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	contracts_for_types = _tmp2_;
#line 95 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 95 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
		if (_inner_error_->domain == CONTRACTOR_CONTRACTOR_ERROR) {
#line 95 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			g_propagate_error (error, _inner_error_);
#line 95 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			return NULL;
#line 403 "ContractMatcher.c"
		} else {
#line 95 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 95 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			g_clear_error (&_inner_error_);
#line 95 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			return NULL;
#line 411 "ContractMatcher.c"
		}
	}
#line 96 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	_tmp3_ = file_size;
#line 96 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	_tmp4_ = contracts_for_types;
#line 96 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	_tmp5_ = contractor_contract_matcher_get_contracts_for_file_size (_tmp3_, _tmp4_, &_inner_error_);
#line 96 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	valid_contracts = _tmp5_;
#line 96 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 96 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
		if (_inner_error_->domain == CONTRACTOR_CONTRACTOR_ERROR) {
#line 96 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			g_propagate_error (error, _inner_error_);
#line 96 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_g_object_unref0 (contracts_for_types);
#line 96 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			return NULL;
#line 432 "ContractMatcher.c"
		} else {
#line 96 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			_g_object_unref0 (contracts_for_types);
#line 96 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 96 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			g_clear_error (&_inner_error_);
#line 96 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
			return NULL;
#line 442 "ContractMatcher.c"
		}
	}
#line 98 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	result = valid_contracts;
#line 98 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	_g_object_unref0 (contracts_for_types);
#line 98 "/builddir/build/BUILD/contractor-0.3.2/src/ContractMatcher.vala"
	return result;
#line 451 "ContractMatcher.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



