/* DBusService.c generated by valac 0.34.4, the Vala compiler
 * generated from DBusService.vala, do not modify */

/*
 * Copyright (C) 2011-2013 elementary Developers
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: ammonkey <am.monkeyd@gmail.com>,
 *          lampe2 <michael@lazarski.me>,
 *          Victor Martinez <victoreduardm@gmail.com>
 *
 * The original Contractor implementation in Python was created by:
 *          Allen Lowe <lallenlowe@gmail.com>
 */
/**
     * Errors specific to the Contractor D-Bus service.
     */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define CONTRACTOR_TYPE_DBUS_SERVICE (contractor_dbus_service_get_type ())
#define CONTRACTOR_DBUS_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTRACTOR_TYPE_DBUS_SERVICE, ContractorDBusService))
#define CONTRACTOR_DBUS_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTRACTOR_TYPE_DBUS_SERVICE, ContractorDBusServiceClass))
#define CONTRACTOR_IS_DBUS_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTRACTOR_TYPE_DBUS_SERVICE))
#define CONTRACTOR_IS_DBUS_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTRACTOR_TYPE_DBUS_SERVICE))
#define CONTRACTOR_DBUS_SERVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTRACTOR_TYPE_DBUS_SERVICE, ContractorDBusServiceClass))

typedef struct _ContractorDBusService ContractorDBusService;
typedef struct _ContractorDBusServiceClass ContractorDBusServiceClass;
typedef struct _ContractorDBusServicePrivate ContractorDBusServicePrivate;

#define CONTRACTOR_TYPE_CONTRACT_SOURCE (contractor_contract_source_get_type ())
#define CONTRACTOR_CONTRACT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTRACTOR_TYPE_CONTRACT_SOURCE, ContractorContractSource))
#define CONTRACTOR_CONTRACT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTRACTOR_TYPE_CONTRACT_SOURCE, ContractorContractSourceClass))
#define CONTRACTOR_IS_CONTRACT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTRACTOR_TYPE_CONTRACT_SOURCE))
#define CONTRACTOR_IS_CONTRACT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTRACTOR_TYPE_CONTRACT_SOURCE))
#define CONTRACTOR_CONTRACT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTRACTOR_TYPE_CONTRACT_SOURCE, ContractorContractSourceClass))

typedef struct _ContractorContractSource ContractorContractSource;
typedef struct _ContractorContractSourceClass ContractorContractSourceClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define CONTRACTOR_TYPE_GENERIC_CONTRACT (contractor_generic_contract_get_type ())
typedef struct _ContractorGenericContract ContractorGenericContract;

#define CONTRACTOR_TYPE_CONTRACT (contractor_contract_get_type ())
#define CONTRACTOR_CONTRACT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTRACTOR_TYPE_CONTRACT, ContractorContract))
#define CONTRACTOR_CONTRACT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTRACTOR_TYPE_CONTRACT, ContractorContractClass))
#define CONTRACTOR_IS_CONTRACT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTRACTOR_TYPE_CONTRACT))
#define CONTRACTOR_IS_CONTRACT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTRACTOR_TYPE_CONTRACT))
#define CONTRACTOR_CONTRACT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTRACTOR_TYPE_CONTRACT, ContractorContractClass))

typedef struct _ContractorContract ContractorContract;
typedef struct _ContractorContractClass ContractorContractClass;
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	CONTRACTOR_CONTRACTOR_ERROR_NO_MIMETYPES_GIVEN
} ContractorContractorError;
#define CONTRACTOR_CONTRACTOR_ERROR contractor_contractor_error_quark ()
struct _ContractorDBusService {
	GObject parent_instance;
	ContractorDBusServicePrivate * priv;
};

struct _ContractorDBusServiceClass {
	GObjectClass parent_class;
};

struct _ContractorDBusServicePrivate {
	ContractorContractSource* contract_source;
};

struct _ContractorGenericContract {
	gchar* id;
	gchar* name;
	gchar* description;
	gchar* icon;
};


static gpointer contractor_dbus_service_parent_class = NULL;

GQuark contractor_contractor_error_quark (void);
GType contractor_dbus_service_get_type (void) G_GNUC_CONST;
guint contractor_dbus_service_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType contractor_contract_source_get_type (void) G_GNUC_CONST;
#define CONTRACTOR_DBUS_SERVICE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CONTRACTOR_TYPE_DBUS_SERVICE, ContractorDBusServicePrivate))
enum  {
	CONTRACTOR_DBUS_SERVICE_DUMMY_PROPERTY
};
ContractorDBusService* contractor_dbus_service_new (void);
ContractorDBusService* contractor_dbus_service_construct (GType object_type);
ContractorContractSource* contractor_contract_source_new (void);
ContractorContractSource* contractor_contract_source_construct (GType object_type);
static void __lambda5_ (ContractorDBusService* self);
static void ___lambda5__contractor_contract_source_changed (ContractorContractSource* _sender, gpointer self);
GType contractor_generic_contract_get_type (void) G_GNUC_CONST;
ContractorGenericContract* contractor_generic_contract_dup (const ContractorGenericContract* self);
void contractor_generic_contract_free (ContractorGenericContract* self);
void contractor_generic_contract_copy (const ContractorGenericContract* self, ContractorGenericContract* dest);
void contractor_generic_contract_destroy (ContractorGenericContract* self);
ContractorGenericContract* contractor_dbus_service_get_contracts_by_mime (ContractorDBusService* self, const gchar* mime_type, int* result_length1, GError** error);
ContractorGenericContract* contractor_dbus_service_get_contracts_by_mimelist (ContractorDBusService* self, gchar** mime_types, int mime_types_length1, int* result_length1, GError** error);
static void _vala_ContractorGenericContract_array_free (ContractorGenericContract* array, gint array_length);
GType contractor_contract_get_type (void) G_GNUC_CONST;
GeeCollection* contractor_contract_source_get_contracts (ContractorContractSource* self);
GeeCollection* contractor_contract_matcher_get_contracts_for_types (gchar** mime_types, int mime_types_length1, GeeCollection* contracts_to_filter, GError** error);
static ContractorGenericContract* contractor_dbus_service_convert_to_generic_contracts (GeeCollection* contracts, int* result_length1);
ContractorGenericContract* contractor_dbus_service_get_contracts_by_file_size (ContractorDBusService* self, gint64 file_size, int* result_length1, GError** error);
GeeCollection* contractor_contract_matcher_get_contracts_for_file_size (gint64 file_size, GeeCollection* contracts_to_filter, GError** error);
ContractorGenericContract* contractor_dbus_service_get_contracts_by_mime_and_file_size (ContractorDBusService* self, const gchar* mime_type, gint64 file_size, int* result_length1, GError** error);
ContractorGenericContract* contractor_dbus_service_get_contracts_by_mimelist_and_file_size (ContractorDBusService* self, gchar** mime_types, int mime_types_length1, gint64 file_size, int* result_length1, GError** error);
GeeCollection* contractor_contract_matcher_get_contracts_for_types_and_file_size (gchar** mime_types, int mime_types_length1, gint64 file_size, GeeCollection* contracts_to_filter, GError** error);
void contractor_dbus_service_execute_with_uri (ContractorDBusService* self, const gchar* id, const gchar* uri, GError** error);
void contractor_dbus_service_execute_with_uri_list (ContractorDBusService* self, const gchar* id, gchar** uris, int uris_length1, GError** error);
ContractorContract* contractor_contract_source_lookup_by_id (ContractorContractSource* self, const gchar* contract_id, GError** error);
void contractor_contract_launch_uris (ContractorContract* self, gchar** uris, int uris_length1, GError** error);
ContractorGenericContract* contractor_dbus_service_list_all_contracts (ContractorDBusService* self, int* result_length1);
void contractor_contract_get_generic (ContractorContract* self, ContractorGenericContract* result);
static void _vala_array_add1 (ContractorGenericContract** array, int* length, int* size, const ContractorGenericContract* value);
static void contractor_dbus_service_finalize (GObject* obj);
static void _dbus_contractor_dbus_service_get_contracts_by_mime (ContractorDBusService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_contractor_dbus_service_get_contracts_by_mimelist (ContractorDBusService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_contractor_dbus_service_get_contracts_by_file_size (ContractorDBusService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_contractor_dbus_service_get_contracts_by_mime_and_file_size (ContractorDBusService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_contractor_dbus_service_get_contracts_by_mimelist_and_file_size (ContractorDBusService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_contractor_dbus_service_execute_with_uri (ContractorDBusService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_contractor_dbus_service_execute_with_uri_list (ContractorDBusService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_contractor_dbus_service_list_all_contracts (ContractorDBusService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void contractor_dbus_service_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* contractor_dbus_service_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean contractor_dbus_service_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_contractor_dbus_service_contracts_changed (GObject* _sender, gpointer* _data);
static void _contractor_dbus_service_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GDBusErrorEntry contractor_contractor_error_entries[] = {{CONTRACTOR_CONTRACTOR_ERROR_NO_MIMETYPES_GIVEN, "org.elementary.ContractorError.NoMimetypesGiven"}};
static const GDBusArgInfo _contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_mime_type = {-1, "mime_type", "s"};
static const GDBusArgInfo _contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_result = {-1, "result", "a(ssss)"};
static const GDBusArgInfo * const _contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_in[] = {&_contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_mime_type, NULL};
static const GDBusArgInfo * const _contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_out[] = {&_contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_result, NULL};
static const GDBusMethodInfo _contractor_dbus_service_dbus_method_info_get_contracts_by_mime = {-1, "GetContractsByMime", (GDBusArgInfo **) (&_contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_in), (GDBusArgInfo **) (&_contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_out)};
static const GDBusArgInfo _contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_mime_types = {-1, "mime_types", "as"};
static const GDBusArgInfo _contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_result = {-1, "result", "a(ssss)"};
static const GDBusArgInfo * const _contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_in[] = {&_contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_mime_types, NULL};
static const GDBusArgInfo * const _contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_out[] = {&_contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_result, NULL};
static const GDBusMethodInfo _contractor_dbus_service_dbus_method_info_get_contracts_by_mimelist = {-1, "GetContractsByMimelist", (GDBusArgInfo **) (&_contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_in), (GDBusArgInfo **) (&_contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_out)};
static const GDBusArgInfo _contractor_dbus_service_dbus_arg_info_get_contracts_by_file_size_file_size = {-1, "file_size", "x"};
static const GDBusArgInfo _contractor_dbus_service_dbus_arg_info_get_contracts_by_file_size_result = {-1, "result", "a(ssss)"};
static const GDBusArgInfo * const _contractor_dbus_service_dbus_arg_info_get_contracts_by_file_size_in[] = {&_contractor_dbus_service_dbus_arg_info_get_contracts_by_file_size_file_size, NULL};
static const GDBusArgInfo * const _contractor_dbus_service_dbus_arg_info_get_contracts_by_file_size_out[] = {&_contractor_dbus_service_dbus_arg_info_get_contracts_by_file_size_result, NULL};
static const GDBusMethodInfo _contractor_dbus_service_dbus_method_info_get_contracts_by_file_size = {-1, "GetContractsByFileSize", (GDBusArgInfo **) (&_contractor_dbus_service_dbus_arg_info_get_contracts_by_file_size_in), (GDBusArgInfo **) (&_contractor_dbus_service_dbus_arg_info_get_contracts_by_file_size_out)};
static const GDBusArgInfo _contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_and_file_size_mime_type = {-1, "mime_type", "s"};
static const GDBusArgInfo _contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_and_file_size_file_size = {-1, "file_size", "x"};
static const GDBusArgInfo _contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_and_file_size_result = {-1, "result", "a(ssss)"};
static const GDBusArgInfo * const _contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_and_file_size_in[] = {&_contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_and_file_size_mime_type, &_contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_and_file_size_file_size, NULL};
static const GDBusArgInfo * const _contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_and_file_size_out[] = {&_contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_and_file_size_result, NULL};
static const GDBusMethodInfo _contractor_dbus_service_dbus_method_info_get_contracts_by_mime_and_file_size = {-1, "GetContractsByMimeAndFileSize", (GDBusArgInfo **) (&_contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_and_file_size_in), (GDBusArgInfo **) (&_contractor_dbus_service_dbus_arg_info_get_contracts_by_mime_and_file_size_out)};
static const GDBusArgInfo _contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_and_file_size_mime_types = {-1, "mime_types", "as"};
static const GDBusArgInfo _contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_and_file_size_file_size = {-1, "file_size", "x"};
static const GDBusArgInfo _contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_and_file_size_result = {-1, "result", "a(ssss)"};
static const GDBusArgInfo * const _contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_and_file_size_in[] = {&_contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_and_file_size_mime_types, &_contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_and_file_size_file_size, NULL};
static const GDBusArgInfo * const _contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_and_file_size_out[] = {&_contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_and_file_size_result, NULL};
static const GDBusMethodInfo _contractor_dbus_service_dbus_method_info_get_contracts_by_mimelist_and_file_size = {-1, "GetContractsByMimelistAndFileSize", (GDBusArgInfo **) (&_contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_and_file_size_in), (GDBusArgInfo **) (&_contractor_dbus_service_dbus_arg_info_get_contracts_by_mimelist_and_file_size_out)};
static const GDBusArgInfo _contractor_dbus_service_dbus_arg_info_execute_with_uri_id = {-1, "id", "s"};
static const GDBusArgInfo _contractor_dbus_service_dbus_arg_info_execute_with_uri_uri = {-1, "uri", "s"};
static const GDBusArgInfo * const _contractor_dbus_service_dbus_arg_info_execute_with_uri_in[] = {&_contractor_dbus_service_dbus_arg_info_execute_with_uri_id, &_contractor_dbus_service_dbus_arg_info_execute_with_uri_uri, NULL};
static const GDBusArgInfo * const _contractor_dbus_service_dbus_arg_info_execute_with_uri_out[] = {NULL};
static const GDBusMethodInfo _contractor_dbus_service_dbus_method_info_execute_with_uri = {-1, "ExecuteWithUri", (GDBusArgInfo **) (&_contractor_dbus_service_dbus_arg_info_execute_with_uri_in), (GDBusArgInfo **) (&_contractor_dbus_service_dbus_arg_info_execute_with_uri_out)};
static const GDBusArgInfo _contractor_dbus_service_dbus_arg_info_execute_with_uri_list_id = {-1, "id", "s"};
static const GDBusArgInfo _contractor_dbus_service_dbus_arg_info_execute_with_uri_list_uris = {-1, "uris", "as"};
static const GDBusArgInfo * const _contractor_dbus_service_dbus_arg_info_execute_with_uri_list_in[] = {&_contractor_dbus_service_dbus_arg_info_execute_with_uri_list_id, &_contractor_dbus_service_dbus_arg_info_execute_with_uri_list_uris, NULL};
static const GDBusArgInfo * const _contractor_dbus_service_dbus_arg_info_execute_with_uri_list_out[] = {NULL};
static const GDBusMethodInfo _contractor_dbus_service_dbus_method_info_execute_with_uri_list = {-1, "ExecuteWithUriList", (GDBusArgInfo **) (&_contractor_dbus_service_dbus_arg_info_execute_with_uri_list_in), (GDBusArgInfo **) (&_contractor_dbus_service_dbus_arg_info_execute_with_uri_list_out)};
static const GDBusArgInfo _contractor_dbus_service_dbus_arg_info_list_all_contracts_result = {-1, "result", "a(ssss)"};
static const GDBusArgInfo * const _contractor_dbus_service_dbus_arg_info_list_all_contracts_in[] = {NULL};
static const GDBusArgInfo * const _contractor_dbus_service_dbus_arg_info_list_all_contracts_out[] = {&_contractor_dbus_service_dbus_arg_info_list_all_contracts_result, NULL};
static const GDBusMethodInfo _contractor_dbus_service_dbus_method_info_list_all_contracts = {-1, "ListAllContracts", (GDBusArgInfo **) (&_contractor_dbus_service_dbus_arg_info_list_all_contracts_in), (GDBusArgInfo **) (&_contractor_dbus_service_dbus_arg_info_list_all_contracts_out)};
static const GDBusMethodInfo * const _contractor_dbus_service_dbus_method_info[] = {&_contractor_dbus_service_dbus_method_info_get_contracts_by_mime, &_contractor_dbus_service_dbus_method_info_get_contracts_by_mimelist, &_contractor_dbus_service_dbus_method_info_get_contracts_by_file_size, &_contractor_dbus_service_dbus_method_info_get_contracts_by_mime_and_file_size, &_contractor_dbus_service_dbus_method_info_get_contracts_by_mimelist_and_file_size, &_contractor_dbus_service_dbus_method_info_execute_with_uri, &_contractor_dbus_service_dbus_method_info_execute_with_uri_list, &_contractor_dbus_service_dbus_method_info_list_all_contracts, NULL};
static const GDBusArgInfo * const _contractor_dbus_service_dbus_arg_info_contracts_changed[] = {NULL};
static const GDBusSignalInfo _contractor_dbus_service_dbus_signal_info_contracts_changed = {-1, "ContractsChanged", (GDBusArgInfo **) (&_contractor_dbus_service_dbus_arg_info_contracts_changed)};
static const GDBusSignalInfo * const _contractor_dbus_service_dbus_signal_info[] = {&_contractor_dbus_service_dbus_signal_info_contracts_changed, NULL};
static const GDBusPropertyInfo * const _contractor_dbus_service_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _contractor_dbus_service_dbus_interface_info = {-1, "org.elementary.Contractor", (GDBusMethodInfo **) (&_contractor_dbus_service_dbus_method_info), (GDBusSignalInfo **) (&_contractor_dbus_service_dbus_signal_info), (GDBusPropertyInfo **) (&_contractor_dbus_service_dbus_property_info)};
static const GDBusInterfaceVTable _contractor_dbus_service_dbus_interface_vtable = {contractor_dbus_service_dbus_interface_method_call, contractor_dbus_service_dbus_interface_get_property, contractor_dbus_service_dbus_interface_set_property};

GQuark contractor_contractor_error_quark (void) {
	static volatile gsize contractor_contractor_error_quark_volatile = 0;
	g_dbus_error_register_error_domain ("contractor_contractor_error-quark", &contractor_contractor_error_quark_volatile, contractor_contractor_error_entries, G_N_ELEMENTS (contractor_contractor_error_entries));
	return (GQuark) contractor_contractor_error_quark_volatile;
}


/**
         * Constructor to create a DBusService object and setup a
         * ContractSource.
         */
static void __lambda5_ (ContractorDBusService* self) {
#line 59 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_signal_emit_by_name (self, "contracts-changed");
#line 222 "DBusService.c"
}


static void ___lambda5__contractor_contract_source_changed (ContractorContractSource* _sender, gpointer self) {
#line 59 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	__lambda5_ ((ContractorDBusService*) self);
#line 229 "DBusService.c"
}


ContractorDBusService* contractor_dbus_service_construct (GType object_type) {
	ContractorDBusService * self = NULL;
	ContractorContractSource* _tmp0_ = NULL;
	ContractorContractSource* _tmp1_ = NULL;
#line 57 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	self = (ContractorDBusService*) g_object_new (object_type, NULL);
#line 58 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp0_ = contractor_contract_source_new ();
#line 58 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_g_object_unref0 (self->priv->contract_source);
#line 58 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	self->priv->contract_source = _tmp0_;
#line 59 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp1_ = self->priv->contract_source;
#line 59 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_signal_connect_object (_tmp1_, "changed", (GCallback) ___lambda5__contractor_contract_source_changed, self, 0);
#line 57 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	return self;
#line 251 "DBusService.c"
}


ContractorDBusService* contractor_dbus_service_new (void) {
#line 57 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	return contractor_dbus_service_construct (CONTRACTOR_TYPE_DBUS_SERVICE);
#line 258 "DBusService.c"
}


/**
         * This method gets an array of GenericContracts filtered by a
         * MIME type.
         *
         * @param mime_type a MIME type string, e.g. text, image
         *
         * @return an array of GenericContracts
         */
static void _vala_ContractorGenericContract_array_free (ContractorGenericContract* array, gint array_length) {
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	if (array != NULL) {
#line 273 "DBusService.c"
		int i;
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
			contractor_generic_contract_destroy (&array[i]);
#line 279 "DBusService.c"
		}
	}
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_free (array);
#line 284 "DBusService.c"
}


ContractorGenericContract* contractor_dbus_service_get_contracts_by_mime (ContractorDBusService* self, const gchar* mime_type, int* result_length1, GError** error) {
	ContractorGenericContract* result = NULL;
	gchar** mime_types = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint mime_types_length1 = 0;
	gint _mime_types_size_ = 0;
	ContractorGenericContract* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	ContractorGenericContract* _tmp5_ = NULL;
	gint _tmp3__length1 = 0;
	gint __tmp3__size_ = 0;
	ContractorGenericContract* _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	ContractorGenericContract* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	GError * _inner_error_ = NULL;
#line 70 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_return_val_if_fail (mime_type != NULL, NULL);
#line 71 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp0_ = mime_type;
#line 71 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 71 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp2_ = g_new0 (gchar*, 1 + 1);
#line 71 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp2_[0] = _tmp1_;
#line 71 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	mime_types = _tmp2_;
#line 71 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	mime_types_length1 = 1;
#line 71 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_mime_types_size_ = mime_types_length1;
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp5_ = contractor_dbus_service_get_contracts_by_mimelist (self, mime_types, mime_types_length1, &_tmp4_, &_inner_error_);
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp3_ = _tmp5_;
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp3__length1 = _tmp4_;
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	__tmp3__size_ = _tmp3__length1;
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		g_propagate_error (error, _inner_error_);
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		mime_types = (_vala_array_free (mime_types, mime_types_length1, (GDestroyNotify) g_free), NULL);
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		return NULL;
#line 340 "DBusService.c"
	}
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp6_ = _tmp3_;
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp6__length1 = _tmp3__length1;
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp3_ = NULL;
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp3__length1 = 0;
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp7_ = _tmp6_;
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp7__length1 = _tmp6__length1;
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	if (result_length1) {
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		*result_length1 = _tmp7__length1;
#line 358 "DBusService.c"
	}
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	result = _tmp7_;
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp3_ = (_vala_ContractorGenericContract_array_free (_tmp3_, _tmp3__length1), NULL);
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	mime_types = (_vala_array_free (mime_types, mime_types_length1, (GDestroyNotify) g_free), NULL);
#line 72 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	return result;
#line 368 "DBusService.c"
}


/**
         * This method gets an array of GenericContracts filtered by an array of
         * MIME types.
         *
         * @param mime_types an array of MIME type strings, e.g. text, image
         *
         * @return an array of GenericContracts
         */
ContractorGenericContract* contractor_dbus_service_get_contracts_by_mimelist (ContractorDBusService* self, gchar** mime_types, int mime_types_length1, int* result_length1, GError** error) {
	ContractorGenericContract* result = NULL;
	GeeCollection* all_contracts = NULL;
	ContractorContractSource* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
	GeeCollection* contracts = NULL;
	gchar** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	GeeCollection* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	ContractorGenericContract* _tmp5_ = NULL;
	ContractorGenericContract* _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	GError * _inner_error_ = NULL;
#line 83 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp0_ = self->priv->contract_source;
#line 84 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp1_ = contractor_contract_source_get_contracts (_tmp0_);
#line 84 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	all_contracts = _tmp1_;
#line 85 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp2_ = mime_types;
#line 85 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp2__length1 = mime_types_length1;
#line 85 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp3_ = contractor_contract_matcher_get_contracts_for_types (_tmp2_, _tmp2__length1, all_contracts, &_inner_error_);
#line 85 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	contracts = _tmp3_;
#line 85 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 85 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		g_propagate_error (error, _inner_error_);
#line 85 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		_g_object_unref0 (all_contracts);
#line 85 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		return NULL;
#line 418 "DBusService.c"
	}
#line 86 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp5_ = contractor_dbus_service_convert_to_generic_contracts (contracts, &_tmp4_);
#line 86 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp6_ = _tmp5_;
#line 86 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp6__length1 = _tmp4_;
#line 86 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	if (result_length1) {
#line 86 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		*result_length1 = _tmp6__length1;
#line 430 "DBusService.c"
	}
#line 86 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	result = _tmp6_;
#line 86 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_g_object_unref0 (contracts);
#line 86 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_g_object_unref0 (all_contracts);
#line 86 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	return result;
#line 440 "DBusService.c"
}


/**
         * This method gets an array of GenericContracts filtered by the file
         * size in bytes.
         *
         * @param file_size the file size in bytes, e.g. from FileInfo.get_size ()
         *
         * @return an array of GenericContracts
         */
ContractorGenericContract* contractor_dbus_service_get_contracts_by_file_size (ContractorDBusService* self, gint64 file_size, int* result_length1, GError** error) {
	ContractorGenericContract* result = NULL;
	GeeCollection* all_contracts = NULL;
	ContractorContractSource* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
	GeeCollection* contracts = NULL;
	gint64 _tmp2_ = 0LL;
	GeeCollection* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	ContractorGenericContract* _tmp5_ = NULL;
	ContractorGenericContract* _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	GError * _inner_error_ = NULL;
#line 97 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 98 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp0_ = self->priv->contract_source;
#line 98 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp1_ = contractor_contract_source_get_contracts (_tmp0_);
#line 98 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	all_contracts = _tmp1_;
#line 99 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp2_ = file_size;
#line 99 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp3_ = contractor_contract_matcher_get_contracts_for_file_size (_tmp2_, all_contracts, &_inner_error_);
#line 99 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	contracts = _tmp3_;
#line 99 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 99 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		g_propagate_error (error, _inner_error_);
#line 99 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		_g_object_unref0 (all_contracts);
#line 99 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		return NULL;
#line 487 "DBusService.c"
	}
#line 100 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp5_ = contractor_dbus_service_convert_to_generic_contracts (contracts, &_tmp4_);
#line 100 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp6_ = _tmp5_;
#line 100 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp6__length1 = _tmp4_;
#line 100 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	if (result_length1) {
#line 100 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		*result_length1 = _tmp6__length1;
#line 499 "DBusService.c"
	}
#line 100 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	result = _tmp6_;
#line 100 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_g_object_unref0 (contracts);
#line 100 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_g_object_unref0 (all_contracts);
#line 100 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	return result;
#line 509 "DBusService.c"
}


/**
         * This method gets an array of GenericContracts filtered by a MIME type
         * and the file size in bytes.
         *
         * @param mime_type a MIME type string, e.g. text, image
         * @param file_size the file size in bytes, e.g. from FileInfo.get_size ()
         *
         * @return an array of GenericContracts
         */
ContractorGenericContract* contractor_dbus_service_get_contracts_by_mime_and_file_size (ContractorDBusService* self, const gchar* mime_type, gint64 file_size, int* result_length1, GError** error) {
	ContractorGenericContract* result = NULL;
	gchar** mime_types = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint mime_types_length1 = 0;
	gint _mime_types_size_ = 0;
	ContractorGenericContract* _tmp3_ = NULL;
	gint64 _tmp4_ = 0LL;
	gint _tmp5_ = 0;
	ContractorGenericContract* _tmp6_ = NULL;
	gint _tmp3__length1 = 0;
	gint __tmp3__size_ = 0;
	ContractorGenericContract* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	ContractorGenericContract* _tmp8_ = NULL;
	gint _tmp8__length1 = 0;
	GError * _inner_error_ = NULL;
#line 112 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 112 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_return_val_if_fail (mime_type != NULL, NULL);
#line 113 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp0_ = mime_type;
#line 113 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 113 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp2_ = g_new0 (gchar*, 1 + 1);
#line 113 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp2_[0] = _tmp1_;
#line 113 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	mime_types = _tmp2_;
#line 113 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	mime_types_length1 = 1;
#line 113 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_mime_types_size_ = mime_types_length1;
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp4_ = file_size;
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp6_ = contractor_dbus_service_get_contracts_by_mimelist_and_file_size (self, mime_types, mime_types_length1, _tmp4_, &_tmp5_, &_inner_error_);
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp3_ = _tmp6_;
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp3__length1 = _tmp5_;
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	__tmp3__size_ = _tmp3__length1;
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		g_propagate_error (error, _inner_error_);
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		mime_types = (_vala_array_free (mime_types, mime_types_length1, (GDestroyNotify) g_free), NULL);
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		return NULL;
#line 577 "DBusService.c"
	}
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp7_ = _tmp3_;
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp7__length1 = _tmp3__length1;
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp3_ = NULL;
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp3__length1 = 0;
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp8_ = _tmp7_;
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp8__length1 = _tmp7__length1;
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	if (result_length1) {
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		*result_length1 = _tmp8__length1;
#line 595 "DBusService.c"
	}
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	result = _tmp8_;
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp3_ = (_vala_ContractorGenericContract_array_free (_tmp3_, _tmp3__length1), NULL);
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	mime_types = (_vala_array_free (mime_types, mime_types_length1, (GDestroyNotify) g_free), NULL);
#line 114 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	return result;
#line 605 "DBusService.c"
}


/**
         * This method gets an array of GenericContracts filtered by an array of
         * MIME types and the file size in bytes.
         *
         * The file size should probably be the sum of all files file size.
         *
         * @param mime_types an array of MIME type strings, e.g. text, image
         * @param file_size the file size in bytes, e.g. from FileInfo.get_size ()
         *
         * @return an array of GenericContracts
         */
ContractorGenericContract* contractor_dbus_service_get_contracts_by_mimelist_and_file_size (ContractorDBusService* self, gchar** mime_types, int mime_types_length1, gint64 file_size, int* result_length1, GError** error) {
	ContractorGenericContract* result = NULL;
	GeeCollection* all_contracts = NULL;
	ContractorContractSource* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
	GeeCollection* contracts = NULL;
	gchar** _tmp2_ = NULL;
	gint _tmp2__length1 = 0;
	gint64 _tmp3_ = 0LL;
	GeeCollection* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	ContractorGenericContract* _tmp6_ = NULL;
	ContractorGenericContract* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	GError * _inner_error_ = NULL;
#line 128 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 129 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp0_ = self->priv->contract_source;
#line 129 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp1_ = contractor_contract_source_get_contracts (_tmp0_);
#line 129 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	all_contracts = _tmp1_;
#line 130 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp2_ = mime_types;
#line 130 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp2__length1 = mime_types_length1;
#line 130 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp3_ = file_size;
#line 130 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp4_ = contractor_contract_matcher_get_contracts_for_types_and_file_size (_tmp2_, _tmp2__length1, _tmp3_, all_contracts, &_inner_error_);
#line 130 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	contracts = _tmp4_;
#line 130 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 130 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		g_propagate_error (error, _inner_error_);
#line 130 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		_g_object_unref0 (all_contracts);
#line 130 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		return NULL;
#line 661 "DBusService.c"
	}
#line 131 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp6_ = contractor_dbus_service_convert_to_generic_contracts (contracts, &_tmp5_);
#line 131 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp7_ = _tmp6_;
#line 131 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp7__length1 = _tmp5_;
#line 131 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	if (result_length1) {
#line 131 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		*result_length1 = _tmp7__length1;
#line 673 "DBusService.c"
	}
#line 131 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	result = _tmp7_;
#line 131 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_g_object_unref0 (contracts);
#line 131 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_g_object_unref0 (all_contracts);
#line 131 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	return result;
#line 683 "DBusService.c"
}


void contractor_dbus_service_execute_with_uri (ContractorDBusService* self, const gchar* id, const gchar* uri, GError** error) {
	gchar** uris = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint uris_length1 = 0;
	gint _uris_size_ = 0;
	const gchar* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
#line 134 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_return_if_fail (self != NULL);
#line 134 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_return_if_fail (id != NULL);
#line 134 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_return_if_fail (uri != NULL);
#line 135 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp0_ = uri;
#line 135 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 135 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp2_ = g_new0 (gchar*, 1 + 1);
#line 135 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp2_[0] = _tmp1_;
#line 135 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	uris = _tmp2_;
#line 135 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	uris_length1 = 1;
#line 135 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_uris_size_ = uris_length1;
#line 136 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp3_ = id;
#line 136 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	contractor_dbus_service_execute_with_uri_list (self, _tmp3_, uris, uris_length1, &_inner_error_);
#line 136 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 136 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		g_propagate_error (error, _inner_error_);
#line 136 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 136 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		return;
#line 728 "DBusService.c"
	}
#line 134 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 732 "DBusService.c"
}


void contractor_dbus_service_execute_with_uri_list (ContractorDBusService* self, const gchar* id, gchar** uris, int uris_length1, GError** error) {
	ContractorContract* contract = NULL;
	ContractorContractSource* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	ContractorContract* _tmp2_ = NULL;
	ContractorContract* _tmp3_ = NULL;
	gchar** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	GError * _inner_error_ = NULL;
#line 139 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_return_if_fail (self != NULL);
#line 139 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_return_if_fail (id != NULL);
#line 140 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp0_ = self->priv->contract_source;
#line 140 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp1_ = id;
#line 140 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp2_ = contractor_contract_source_lookup_by_id (_tmp0_, _tmp1_, &_inner_error_);
#line 140 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	contract = _tmp2_;
#line 140 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 140 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		g_propagate_error (error, _inner_error_);
#line 140 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		return;
#line 763 "DBusService.c"
	}
#line 141 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp3_ = contract;
#line 141 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp4_ = uris;
#line 141 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp4__length1 = uris_length1;
#line 141 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	contractor_contract_launch_uris (_tmp3_, _tmp4_, _tmp4__length1, &_inner_error_);
#line 141 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 141 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		g_propagate_error (error, _inner_error_);
#line 141 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		_g_object_unref0 (contract);
#line 141 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		return;
#line 781 "DBusService.c"
	}
#line 139 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_g_object_unref0 (contract);
#line 785 "DBusService.c"
}


/**
         * This method gets an array of GenericContracts containing all
         * contracts that exist.
         *
         * @return an array of GenericContracts containing all contracts
         */
ContractorGenericContract* contractor_dbus_service_list_all_contracts (ContractorDBusService* self, int* result_length1) {
	ContractorGenericContract* result = NULL;
	GeeCollection* contracts = NULL;
	ContractorContractSource* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	ContractorGenericContract* _tmp3_ = NULL;
	ContractorGenericContract* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
#line 150 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 151 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp0_ = self->priv->contract_source;
#line 151 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp1_ = contractor_contract_source_get_contracts (_tmp0_);
#line 151 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	contracts = _tmp1_;
#line 152 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp3_ = contractor_dbus_service_convert_to_generic_contracts (contracts, &_tmp2_);
#line 152 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp4_ = _tmp3_;
#line 152 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp4__length1 = _tmp2_;
#line 152 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	if (result_length1) {
#line 152 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		*result_length1 = _tmp4__length1;
#line 822 "DBusService.c"
	}
#line 152 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	result = _tmp4_;
#line 152 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_g_object_unref0 (contracts);
#line 152 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	return result;
#line 830 "DBusService.c"
}


/**
         * Converts a Collection of Contracts into an array of
         * GenericContracts.
         *
         * @return an array of GenericContracts
         */
static void _vala_array_add1 (ContractorGenericContract** array, int* length, int* size, const ContractorGenericContract* value) {
#line 165 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	if ((*length) == (*size)) {
#line 165 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 165 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		*array = g_renew (ContractorGenericContract, *array, *size);
#line 847 "DBusService.c"
	}
#line 165 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	(*array)[(*length)++] = *value;
#line 851 "DBusService.c"
}


static ContractorGenericContract* contractor_dbus_service_convert_to_generic_contracts (GeeCollection* contracts, int* result_length1) {
	ContractorGenericContract* result = NULL;
	ContractorGenericContract* generic_contracts = NULL;
	ContractorGenericContract* _tmp0_ = NULL;
	gint generic_contracts_length1 = 0;
	gint _generic_contracts_size_ = 0;
	ContractorGenericContract* _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
#line 161 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_return_val_if_fail (contracts != NULL, NULL);
#line 162 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp0_ = g_new0 (ContractorGenericContract, 0);
#line 162 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	generic_contracts = _tmp0_;
#line 162 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	generic_contracts_length1 = 0;
#line 162 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_generic_contracts_size_ = generic_contracts_length1;
#line 873 "DBusService.c"
	{
		GeeIterator* _contract_it = NULL;
		GeeCollection* _tmp1_ = NULL;
		GeeIterator* _tmp2_ = NULL;
#line 164 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		_tmp1_ = contracts;
#line 164 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 164 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		_contract_it = _tmp2_;
#line 164 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		while (TRUE) {
#line 886 "DBusService.c"
			GeeIterator* _tmp3_ = NULL;
			gboolean _tmp4_ = FALSE;
			ContractorContract* contract = NULL;
			GeeIterator* _tmp5_ = NULL;
			gpointer _tmp6_ = NULL;
			ContractorGenericContract* _tmp7_ = NULL;
			gint _tmp7__length1 = 0;
			ContractorContract* _tmp8_ = NULL;
			ContractorGenericContract _tmp9_ = {0};
#line 164 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
			_tmp3_ = _contract_it;
#line 164 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 164 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
			if (!_tmp4_) {
#line 164 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
				break;
#line 904 "DBusService.c"
			}
#line 164 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
			_tmp5_ = _contract_it;
#line 164 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 164 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
			contract = (ContractorContract*) _tmp6_;
#line 165 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
			_tmp7_ = generic_contracts;
#line 165 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
			_tmp7__length1 = generic_contracts_length1;
#line 165 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
			_tmp8_ = contract;
#line 165 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
			contractor_contract_get_generic (_tmp8_, &_tmp9_);
#line 165 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
			_vala_array_add1 (&generic_contracts, &generic_contracts_length1, &_generic_contracts_size_, &_tmp9_);
#line 164 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
			_g_object_unref0 (contract);
#line 924 "DBusService.c"
		}
#line 164 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		_g_object_unref0 (_contract_it);
#line 928 "DBusService.c"
	}
#line 168 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp10_ = generic_contracts;
#line 168 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_tmp10__length1 = generic_contracts_length1;
#line 168 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	if (result_length1) {
#line 168 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
		*result_length1 = _tmp10__length1;
#line 938 "DBusService.c"
	}
#line 168 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	result = _tmp10_;
#line 168 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	return result;
#line 944 "DBusService.c"
}


static void contractor_dbus_service_class_init (ContractorDBusServiceClass * klass) {
#line 42 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	contractor_dbus_service_parent_class = g_type_class_peek_parent (klass);
#line 42 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_type_class_add_private (klass, sizeof (ContractorDBusServicePrivate));
#line 42 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	G_OBJECT_CLASS (klass)->finalize = contractor_dbus_service_finalize;
#line 955 "DBusService.c"
	/**
	         * Signal which gets sent when Contracts change.
	         */
#line 42 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	g_signal_new ("contracts_changed", CONTRACTOR_TYPE_DBUS_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 961 "DBusService.c"
}


static void contractor_dbus_service_instance_init (ContractorDBusService * self) {
#line 42 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	self->priv = CONTRACTOR_DBUS_SERVICE_GET_PRIVATE (self);
#line 968 "DBusService.c"
}


static void contractor_dbus_service_finalize (GObject* obj) {
	ContractorDBusService * self;
#line 42 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTRACTOR_TYPE_DBUS_SERVICE, ContractorDBusService);
#line 51 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	_g_object_unref0 (self->priv->contract_source);
#line 42 "/builddir/build/BUILD/contractor-0.3.2/src/DBusService.vala"
	G_OBJECT_CLASS (contractor_dbus_service_parent_class)->finalize (obj);
#line 980 "DBusService.c"
}


/**
     * A D-Bus service handling requests for Contracts defined by .contract
     * files.
     */
GType contractor_dbus_service_get_type (void) {
	static volatile gsize contractor_dbus_service_type_id__volatile = 0;
	if (g_once_init_enter (&contractor_dbus_service_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContractorDBusServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contractor_dbus_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContractorDBusService), 0, (GInstanceInitFunc) contractor_dbus_service_instance_init, NULL };
		GType contractor_dbus_service_type_id;
		contractor_dbus_service_type_id = g_type_register_static (G_TYPE_OBJECT, "ContractorDBusService", &g_define_type_info, 0);
		g_type_set_qdata (contractor_dbus_service_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) contractor_dbus_service_register_object);
		g_once_init_leave (&contractor_dbus_service_type_id__volatile, contractor_dbus_service_type_id);
	}
	return contractor_dbus_service_type_id__volatile;
}


static void _dbus_contractor_dbus_service_get_contracts_by_mime (ContractorDBusService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* mime_type = NULL;
	GVariant* _tmp0_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	ContractorGenericContract* result;
	int result_length1 = 0;
	ContractorGenericContract* _tmp1_;
	GVariantBuilder _tmp2_;
	int _tmp3_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp0_ = g_variant_iter_next_value (&_arguments_iter);
	mime_type = g_variant_dup_string (_tmp0_, NULL);
	g_variant_unref (_tmp0_);
	result = contractor_dbus_service_get_contracts_by_mime (self, mime_type, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp1_ = result;
	g_variant_builder_init (&_tmp2_, G_VARIANT_TYPE ("a(ssss)"));
	for (_tmp3_ = 0; _tmp3_ < result_length1; _tmp3_++) {
		GVariantBuilder _tmp4_;
		g_variant_builder_init (&_tmp4_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp4_, g_variant_new_string ((*_tmp1_).id));
		g_variant_builder_add_value (&_tmp4_, g_variant_new_string ((*_tmp1_).name));
		g_variant_builder_add_value (&_tmp4_, g_variant_new_string ((*_tmp1_).description));
		g_variant_builder_add_value (&_tmp4_, g_variant_new_string ((*_tmp1_).icon));
		g_variant_builder_add_value (&_tmp2_, g_variant_builder_end (&_tmp4_));
		_tmp1_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp2_));
	result = (_vala_ContractorGenericContract_array_free (result, result_length1), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (mime_type);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_contractor_dbus_service_get_contracts_by_mimelist (ContractorDBusService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar** mime_types = NULL;
	int mime_types_length1 = 0;
	GVariant* _tmp5_;
	gchar** _tmp6_;
	int _tmp6__length;
	int _tmp6__size;
	int _tmp6__length1;
	GVariantIter _tmp7_;
	GVariant* _tmp8_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	ContractorGenericContract* result;
	int result_length1 = 0;
	ContractorGenericContract* _tmp9_;
	GVariantBuilder _tmp10_;
	int _tmp11_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp5_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp6_ = g_new (gchar*, 5);
	_tmp6__length = 0;
	_tmp6__size = 4;
	_tmp6__length1 = 0;
	g_variant_iter_init (&_tmp7_, _tmp5_);
	for (; (_tmp8_ = g_variant_iter_next_value (&_tmp7_)) != NULL; _tmp6__length1++) {
		if (_tmp6__size == _tmp6__length) {
			_tmp6__size = 2 * _tmp6__size;
			_tmp6_ = g_renew (gchar*, _tmp6_, _tmp6__size + 1);
		}
		_tmp6_[_tmp6__length++] = g_variant_dup_string (_tmp8_, NULL);
		g_variant_unref (_tmp8_);
	}
	mime_types_length1 = _tmp6__length1;
	_tmp6_[_tmp6__length] = NULL;
	mime_types = _tmp6_;
	g_variant_unref (_tmp5_);
	result = contractor_dbus_service_get_contracts_by_mimelist (self, mime_types, mime_types_length1, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp9_ = result;
	g_variant_builder_init (&_tmp10_, G_VARIANT_TYPE ("a(ssss)"));
	for (_tmp11_ = 0; _tmp11_ < result_length1; _tmp11_++) {
		GVariantBuilder _tmp12_;
		g_variant_builder_init (&_tmp12_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp12_, g_variant_new_string ((*_tmp9_).id));
		g_variant_builder_add_value (&_tmp12_, g_variant_new_string ((*_tmp9_).name));
		g_variant_builder_add_value (&_tmp12_, g_variant_new_string ((*_tmp9_).description));
		g_variant_builder_add_value (&_tmp12_, g_variant_new_string ((*_tmp9_).icon));
		g_variant_builder_add_value (&_tmp10_, g_variant_builder_end (&_tmp12_));
		_tmp9_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp10_));
	result = (_vala_ContractorGenericContract_array_free (result, result_length1), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	mime_types = (_vala_array_free (mime_types, mime_types_length1, (GDestroyNotify) g_free), NULL);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_contractor_dbus_service_get_contracts_by_file_size (ContractorDBusService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gint64 file_size = 0LL;
	GVariant* _tmp13_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	ContractorGenericContract* result;
	int result_length1 = 0;
	ContractorGenericContract* _tmp14_;
	GVariantBuilder _tmp15_;
	int _tmp16_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp13_ = g_variant_iter_next_value (&_arguments_iter);
	file_size = g_variant_get_int64 (_tmp13_);
	g_variant_unref (_tmp13_);
	result = contractor_dbus_service_get_contracts_by_file_size (self, file_size, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp14_ = result;
	g_variant_builder_init (&_tmp15_, G_VARIANT_TYPE ("a(ssss)"));
	for (_tmp16_ = 0; _tmp16_ < result_length1; _tmp16_++) {
		GVariantBuilder _tmp17_;
		g_variant_builder_init (&_tmp17_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp17_, g_variant_new_string ((*_tmp14_).id));
		g_variant_builder_add_value (&_tmp17_, g_variant_new_string ((*_tmp14_).name));
		g_variant_builder_add_value (&_tmp17_, g_variant_new_string ((*_tmp14_).description));
		g_variant_builder_add_value (&_tmp17_, g_variant_new_string ((*_tmp14_).icon));
		g_variant_builder_add_value (&_tmp15_, g_variant_builder_end (&_tmp17_));
		_tmp14_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp15_));
	result = (_vala_ContractorGenericContract_array_free (result, result_length1), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_contractor_dbus_service_get_contracts_by_mime_and_file_size (ContractorDBusService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* mime_type = NULL;
	GVariant* _tmp18_;
	gint64 file_size = 0LL;
	GVariant* _tmp19_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	ContractorGenericContract* result;
	int result_length1 = 0;
	ContractorGenericContract* _tmp20_;
	GVariantBuilder _tmp21_;
	int _tmp22_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp18_ = g_variant_iter_next_value (&_arguments_iter);
	mime_type = g_variant_dup_string (_tmp18_, NULL);
	g_variant_unref (_tmp18_);
	_tmp19_ = g_variant_iter_next_value (&_arguments_iter);
	file_size = g_variant_get_int64 (_tmp19_);
	g_variant_unref (_tmp19_);
	result = contractor_dbus_service_get_contracts_by_mime_and_file_size (self, mime_type, file_size, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp20_ = result;
	g_variant_builder_init (&_tmp21_, G_VARIANT_TYPE ("a(ssss)"));
	for (_tmp22_ = 0; _tmp22_ < result_length1; _tmp22_++) {
		GVariantBuilder _tmp23_;
		g_variant_builder_init (&_tmp23_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp23_, g_variant_new_string ((*_tmp20_).id));
		g_variant_builder_add_value (&_tmp23_, g_variant_new_string ((*_tmp20_).name));
		g_variant_builder_add_value (&_tmp23_, g_variant_new_string ((*_tmp20_).description));
		g_variant_builder_add_value (&_tmp23_, g_variant_new_string ((*_tmp20_).icon));
		g_variant_builder_add_value (&_tmp21_, g_variant_builder_end (&_tmp23_));
		_tmp20_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp21_));
	result = (_vala_ContractorGenericContract_array_free (result, result_length1), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (mime_type);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_contractor_dbus_service_get_contracts_by_mimelist_and_file_size (ContractorDBusService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar** mime_types = NULL;
	int mime_types_length1 = 0;
	GVariant* _tmp24_;
	gchar** _tmp25_;
	int _tmp25__length;
	int _tmp25__size;
	int _tmp25__length1;
	GVariantIter _tmp26_;
	GVariant* _tmp27_;
	gint64 file_size = 0LL;
	GVariant* _tmp28_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	ContractorGenericContract* result;
	int result_length1 = 0;
	ContractorGenericContract* _tmp29_;
	GVariantBuilder _tmp30_;
	int _tmp31_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp24_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp25_ = g_new (gchar*, 5);
	_tmp25__length = 0;
	_tmp25__size = 4;
	_tmp25__length1 = 0;
	g_variant_iter_init (&_tmp26_, _tmp24_);
	for (; (_tmp27_ = g_variant_iter_next_value (&_tmp26_)) != NULL; _tmp25__length1++) {
		if (_tmp25__size == _tmp25__length) {
			_tmp25__size = 2 * _tmp25__size;
			_tmp25_ = g_renew (gchar*, _tmp25_, _tmp25__size + 1);
		}
		_tmp25_[_tmp25__length++] = g_variant_dup_string (_tmp27_, NULL);
		g_variant_unref (_tmp27_);
	}
	mime_types_length1 = _tmp25__length1;
	_tmp25_[_tmp25__length] = NULL;
	mime_types = _tmp25_;
	g_variant_unref (_tmp24_);
	_tmp28_ = g_variant_iter_next_value (&_arguments_iter);
	file_size = g_variant_get_int64 (_tmp28_);
	g_variant_unref (_tmp28_);
	result = contractor_dbus_service_get_contracts_by_mimelist_and_file_size (self, mime_types, mime_types_length1, file_size, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp29_ = result;
	g_variant_builder_init (&_tmp30_, G_VARIANT_TYPE ("a(ssss)"));
	for (_tmp31_ = 0; _tmp31_ < result_length1; _tmp31_++) {
		GVariantBuilder _tmp32_;
		g_variant_builder_init (&_tmp32_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp32_, g_variant_new_string ((*_tmp29_).id));
		g_variant_builder_add_value (&_tmp32_, g_variant_new_string ((*_tmp29_).name));
		g_variant_builder_add_value (&_tmp32_, g_variant_new_string ((*_tmp29_).description));
		g_variant_builder_add_value (&_tmp32_, g_variant_new_string ((*_tmp29_).icon));
		g_variant_builder_add_value (&_tmp30_, g_variant_builder_end (&_tmp32_));
		_tmp29_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp30_));
	result = (_vala_ContractorGenericContract_array_free (result, result_length1), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	mime_types = (_vala_array_free (mime_types, mime_types_length1, (GDestroyNotify) g_free), NULL);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_contractor_dbus_service_execute_with_uri (ContractorDBusService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* id = NULL;
	GVariant* _tmp33_;
	gchar* uri = NULL;
	GVariant* _tmp34_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp33_ = g_variant_iter_next_value (&_arguments_iter);
	id = g_variant_dup_string (_tmp33_, NULL);
	g_variant_unref (_tmp33_);
	_tmp34_ = g_variant_iter_next_value (&_arguments_iter);
	uri = g_variant_dup_string (_tmp34_, NULL);
	g_variant_unref (_tmp34_);
	contractor_dbus_service_execute_with_uri (self, id, uri, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (id);
	_g_free0 (uri);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_contractor_dbus_service_execute_with_uri_list (ContractorDBusService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* id = NULL;
	GVariant* _tmp35_;
	gchar** uris = NULL;
	int uris_length1 = 0;
	GVariant* _tmp36_;
	gchar** _tmp37_;
	int _tmp37__length;
	int _tmp37__size;
	int _tmp37__length1;
	GVariantIter _tmp38_;
	GVariant* _tmp39_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp35_ = g_variant_iter_next_value (&_arguments_iter);
	id = g_variant_dup_string (_tmp35_, NULL);
	g_variant_unref (_tmp35_);
	_tmp36_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp37_ = g_new (gchar*, 5);
	_tmp37__length = 0;
	_tmp37__size = 4;
	_tmp37__length1 = 0;
	g_variant_iter_init (&_tmp38_, _tmp36_);
	for (; (_tmp39_ = g_variant_iter_next_value (&_tmp38_)) != NULL; _tmp37__length1++) {
		if (_tmp37__size == _tmp37__length) {
			_tmp37__size = 2 * _tmp37__size;
			_tmp37_ = g_renew (gchar*, _tmp37_, _tmp37__size + 1);
		}
		_tmp37_[_tmp37__length++] = g_variant_dup_string (_tmp39_, NULL);
		g_variant_unref (_tmp39_);
	}
	uris_length1 = _tmp37__length1;
	_tmp37_[_tmp37__length] = NULL;
	uris = _tmp37_;
	g_variant_unref (_tmp36_);
	contractor_dbus_service_execute_with_uri_list (self, id, uris, uris_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (id);
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_contractor_dbus_service_list_all_contracts (ContractorDBusService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	ContractorGenericContract* result;
	int result_length1 = 0;
	ContractorGenericContract* _tmp40_;
	GVariantBuilder _tmp41_;
	int _tmp42_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = contractor_dbus_service_list_all_contracts (self, &result_length1);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp40_ = result;
	g_variant_builder_init (&_tmp41_, G_VARIANT_TYPE ("a(ssss)"));
	for (_tmp42_ = 0; _tmp42_ < result_length1; _tmp42_++) {
		GVariantBuilder _tmp43_;
		g_variant_builder_init (&_tmp43_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp43_, g_variant_new_string ((*_tmp40_).id));
		g_variant_builder_add_value (&_tmp43_, g_variant_new_string ((*_tmp40_).name));
		g_variant_builder_add_value (&_tmp43_, g_variant_new_string ((*_tmp40_).description));
		g_variant_builder_add_value (&_tmp43_, g_variant_new_string ((*_tmp40_).icon));
		g_variant_builder_add_value (&_tmp41_, g_variant_builder_end (&_tmp43_));
		_tmp40_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp41_));
	result = (_vala_ContractorGenericContract_array_free (result, result_length1), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void contractor_dbus_service_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GetContractsByMime") == 0) {
		_dbus_contractor_dbus_service_get_contracts_by_mime (object, parameters, invocation);
	} else if (strcmp (method_name, "GetContractsByMimelist") == 0) {
		_dbus_contractor_dbus_service_get_contracts_by_mimelist (object, parameters, invocation);
	} else if (strcmp (method_name, "GetContractsByFileSize") == 0) {
		_dbus_contractor_dbus_service_get_contracts_by_file_size (object, parameters, invocation);
	} else if (strcmp (method_name, "GetContractsByMimeAndFileSize") == 0) {
		_dbus_contractor_dbus_service_get_contracts_by_mime_and_file_size (object, parameters, invocation);
	} else if (strcmp (method_name, "GetContractsByMimelistAndFileSize") == 0) {
		_dbus_contractor_dbus_service_get_contracts_by_mimelist_and_file_size (object, parameters, invocation);
	} else if (strcmp (method_name, "ExecuteWithUri") == 0) {
		_dbus_contractor_dbus_service_execute_with_uri (object, parameters, invocation);
	} else if (strcmp (method_name, "ExecuteWithUriList") == 0) {
		_dbus_contractor_dbus_service_execute_with_uri_list (object, parameters, invocation);
	} else if (strcmp (method_name, "ListAllContracts") == 0) {
		_dbus_contractor_dbus_service_list_all_contracts (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* contractor_dbus_service_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean contractor_dbus_service_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_contractor_dbus_service_contracts_changed (GObject* _sender, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.elementary.Contractor", "ContractsChanged", _arguments, NULL);
}


guint contractor_dbus_service_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_contractor_dbus_service_dbus_interface_info), &_contractor_dbus_service_dbus_interface_vtable, data, _contractor_dbus_service_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "contracts-changed", (GCallback) _dbus_contractor_dbus_service_contracts_changed, data);
	return result;
}


static void _contractor_dbus_service_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_contractor_dbus_service_contracts_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



