/* FileService.c generated by valac 0.34.4, the Vala compiler
 * generated from FileService.vala, do not modify */

/*
 * Copyright (C) 2011-2013 elementary Developers
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: ammonkey <am.monkeyd@gmail.com>,
 *          lampe2 <michael@lazarski.me>,
 *          Akshay Shekher <voldyman666@gmail.com>,
 *          Victor Martinez <victoreduardm@gmail.com>
 *
 * Initial implementation of FileService was heavily inspired by
 * Synapse DesktopFileService. Kudos to the Synapse's developers!
 *
 * The original Contractor implementation in Python was created by:
 *          Allen Lowe <lallenlowe@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define CONTRACTOR_TYPE_FILE_SERVICE (contractor_file_service_get_type ())
#define CONTRACTOR_FILE_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTRACTOR_TYPE_FILE_SERVICE, ContractorFileService))
#define CONTRACTOR_FILE_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTRACTOR_TYPE_FILE_SERVICE, ContractorFileServiceClass))
#define CONTRACTOR_IS_FILE_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTRACTOR_TYPE_FILE_SERVICE))
#define CONTRACTOR_IS_FILE_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTRACTOR_TYPE_FILE_SERVICE))
#define CONTRACTOR_FILE_SERVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTRACTOR_TYPE_FILE_SERVICE, ContractorFileServiceClass))

typedef struct _ContractorFileService ContractorFileService;
typedef struct _ContractorFileServiceClass ContractorFileServiceClass;
typedef struct _ContractorFileServicePrivate ContractorFileServicePrivate;

#define CONTRACTOR_TYPE_CONTRACT_DIRECTORY (contractor_contract_directory_get_type ())
#define CONTRACTOR_CONTRACT_DIRECTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTRACTOR_TYPE_CONTRACT_DIRECTORY, ContractorContractDirectory))
#define CONTRACTOR_CONTRACT_DIRECTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTRACTOR_TYPE_CONTRACT_DIRECTORY, ContractorContractDirectoryClass))
#define CONTRACTOR_IS_CONTRACT_DIRECTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTRACTOR_TYPE_CONTRACT_DIRECTORY))
#define CONTRACTOR_IS_CONTRACT_DIRECTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTRACTOR_TYPE_CONTRACT_DIRECTORY))
#define CONTRACTOR_CONTRACT_DIRECTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTRACTOR_TYPE_CONTRACT_DIRECTORY, ContractorContractDirectoryClass))

typedef struct _ContractorContractDirectory ContractorContractDirectory;
typedef struct _ContractorContractDirectoryClass ContractorContractDirectoryClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ContractorFileService {
	GObject parent_instance;
	ContractorFileServicePrivate * priv;
};

struct _ContractorFileServiceClass {
	GObjectClass parent_class;
};

struct _ContractorFileServicePrivate {
	GeeList* directories;
};


static gpointer contractor_file_service_parent_class = NULL;

GType contractor_file_service_get_type (void) G_GNUC_CONST;
GType contractor_contract_directory_get_type (void) G_GNUC_CONST;
#define CONTRACTOR_FILE_SERVICE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CONTRACTOR_TYPE_FILE_SERVICE, ContractorFileServicePrivate))
enum  {
	CONTRACTOR_FILE_SERVICE_DUMMY_PROPERTY
};
#define CONTRACTOR_FILE_SERVICE_CONTRACT_DATA_DIR_NAME "contractor"
ContractorFileService* contractor_file_service_new (void);
ContractorFileService* contractor_file_service_construct (GType object_type);
static void contractor_file_service_set_up_directories (ContractorFileService* self);
GeeList* contractor_file_service_load_contract_files (ContractorFileService* self);
GeeList* contractor_contract_directory_lookup_contract_files (ContractorContractDirectory* self);
static void _vala_array_add2 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add3 (gchar*** array, int* length, int* size, gchar* value);
ContractorContractDirectory* contractor_contract_directory_new (GFile* directory);
ContractorContractDirectory* contractor_contract_directory_construct (GType object_type, GFile* directory);
static void ____lambda4_ (ContractorFileService* self);
static void _____lambda4__contractor_contract_directory_changed (ContractorContractDirectory* _sender, gpointer self);
static void contractor_file_service_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


ContractorFileService* contractor_file_service_construct (GType object_type) {
	ContractorFileService * self = NULL;
	GeeLinkedList* _tmp0_ = NULL;
#line 38 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	self = (ContractorFileService*) g_object_new (object_type, NULL);
#line 39 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	_tmp0_ = gee_linked_list_new (CONTRACTOR_TYPE_CONTRACT_DIRECTORY, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 39 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	_g_object_unref0 (self->priv->directories);
#line 39 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	self->priv->directories = (GeeList*) _tmp0_;
#line 40 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	contractor_file_service_set_up_directories (self);
#line 38 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	return self;
#line 119 "FileService.c"
}


ContractorFileService* contractor_file_service_new (void) {
#line 38 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	return contractor_file_service_construct (CONTRACTOR_TYPE_FILE_SERVICE);
#line 126 "FileService.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	return self ? g_object_ref (self) : NULL;
#line 133 "FileService.c"
}


GeeList* contractor_file_service_load_contract_files (ContractorFileService* self) {
	GeeList* result = NULL;
	GeeLinkedList* contract_files = NULL;
	GeeLinkedList* _tmp0_ = NULL;
#line 43 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	_tmp0_ = gee_linked_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 44 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	contract_files = _tmp0_;
#line 147 "FileService.c"
	{
		GeeList* _directory_list = NULL;
		GeeList* _tmp1_ = NULL;
		GeeList* _tmp2_ = NULL;
		gint _directory_size = 0;
		GeeList* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		gint _directory_index = 0;
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		_tmp1_ = self->priv->directories;
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		_directory_list = _tmp2_;
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		_tmp3_ = _directory_list;
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		_tmp5_ = _tmp4_;
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		_directory_size = _tmp5_;
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		_directory_index = -1;
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		while (TRUE) {
#line 175 "FileService.c"
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			gint _tmp8_ = 0;
			ContractorContractDirectory* directory = NULL;
			GeeList* _tmp9_ = NULL;
			gint _tmp10_ = 0;
			gpointer _tmp11_ = NULL;
			GeeLinkedList* _tmp12_ = NULL;
			ContractorContractDirectory* _tmp13_ = NULL;
			GeeList* _tmp14_ = NULL;
			GeeList* _tmp15_ = NULL;
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			_tmp6_ = _directory_index;
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			_directory_index = _tmp6_ + 1;
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			_tmp7_ = _directory_index;
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			_tmp8_ = _directory_size;
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				break;
#line 199 "FileService.c"
			}
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			_tmp9_ = _directory_list;
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			_tmp10_ = _directory_index;
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			_tmp11_ = gee_list_get (_tmp9_, _tmp10_);
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			directory = (ContractorContractDirectory*) _tmp11_;
#line 47 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			_tmp12_ = contract_files;
#line 47 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			_tmp13_ = directory;
#line 47 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			_tmp14_ = contractor_contract_directory_lookup_contract_files (_tmp13_);
#line 47 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			_tmp15_ = _tmp14_;
#line 47 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			gee_collection_add_all ((GeeCollection*) _tmp12_, (GeeCollection*) _tmp15_);
#line 47 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			_g_object_unref0 (_tmp15_);
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			_g_object_unref0 (directory);
#line 223 "FileService.c"
		}
#line 46 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		_g_object_unref0 (_directory_list);
#line 227 "FileService.c"
	}
#line 50 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	result = (GeeList*) contract_files;
#line 50 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	return result;
#line 233 "FileService.c"
}


static void _vala_array_add2 (gchar*** array, int* length, int* size, gchar* value) {
#line 57 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	if ((*length) == (*size)) {
#line 57 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 57 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 244 "FileService.c"
	}
#line 57 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	(*array)[(*length)++] = value;
#line 57 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	(*array)[*length] = NULL;
#line 250 "FileService.c"
}


static void _vala_array_add3 (gchar*** array, int* length, int* size, gchar* value) {
#line 60 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	if ((*length) == (*size)) {
#line 60 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 60 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 261 "FileService.c"
	}
#line 60 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	(*array)[(*length)++] = value;
#line 60 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	(*array)[*length] = NULL;
#line 267 "FileService.c"
}


static void ____lambda4_ (ContractorFileService* self) {
#line 67 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	g_signal_emit_by_name (self, "contract-files-changed");
#line 274 "FileService.c"
}


static void _____lambda4__contractor_contract_directory_changed (ContractorContractDirectory* _sender, gpointer self) {
#line 67 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	____lambda4_ ((ContractorFileService*) self);
#line 281 "FileService.c"
}


static void contractor_file_service_set_up_directories (ContractorFileService* self) {
	gchar** data_dir_paths = NULL;
	gchar** _tmp0_ = NULL;
	gint data_dir_paths_length1 = 0;
	gint _data_dir_paths_size_ = 0;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar** _tmp4_ = NULL;
	gchar** _tmp5_ = NULL;
	gchar** _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
#line 53 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	g_return_if_fail (self != NULL);
#line 54 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 54 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	data_dir_paths = _tmp0_;
#line 54 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	data_dir_paths_length1 = 0;
#line 54 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	_data_dir_paths_size_ = data_dir_paths_length1;
#line 57 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	_tmp1_ = data_dir_paths;
#line 57 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	_tmp1__length1 = data_dir_paths_length1;
#line 57 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	_tmp2_ = g_get_user_data_dir ();
#line 57 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 57 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	_vala_array_add2 (&data_dir_paths, &data_dir_paths_length1, &_data_dir_paths_size_, _tmp3_);
#line 59 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	_tmp5_ = _tmp4_ = g_get_system_data_dirs ();
#line 320 "FileService.c"
	{
		gchar** data_dir_collection = NULL;
		gint data_dir_collection_length1 = 0;
		gint _data_dir_collection_size_ = 0;
		gint data_dir_it = 0;
#line 59 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		data_dir_collection = _tmp5_;
#line 59 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		data_dir_collection_length1 = _vala_array_length (_tmp4_);
#line 59 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		for (data_dir_it = 0; data_dir_it < _vala_array_length (_tmp4_); data_dir_it = data_dir_it + 1) {
#line 332 "FileService.c"
			gchar* _tmp6_ = NULL;
			gchar* data_dir = NULL;
#line 59 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			_tmp6_ = g_strdup (data_dir_collection[data_dir_it]);
#line 59 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			data_dir = _tmp6_;
#line 339 "FileService.c"
			{
				gchar** _tmp7_ = NULL;
				gint _tmp7__length1 = 0;
				const gchar* _tmp8_ = NULL;
				gchar* _tmp9_ = NULL;
#line 60 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_tmp7_ = data_dir_paths;
#line 60 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_tmp7__length1 = data_dir_paths_length1;
#line 60 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_tmp8_ = data_dir;
#line 60 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_tmp9_ = g_strdup (_tmp8_);
#line 60 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_vala_array_add3 (&data_dir_paths, &data_dir_paths_length1, &_data_dir_paths_size_, _tmp9_);
#line 59 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_g_free0 (data_dir);
#line 357 "FileService.c"
			}
		}
	}
#line 63 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	_tmp10_ = data_dir_paths;
#line 63 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	_tmp10__length1 = data_dir_paths_length1;
#line 365 "FileService.c"
	{
		gchar** path_collection = NULL;
		gint path_collection_length1 = 0;
		gint _path_collection_size_ = 0;
		gint path_it = 0;
#line 63 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		path_collection = _tmp10_;
#line 63 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		path_collection_length1 = _tmp10__length1;
#line 63 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
		for (path_it = 0; path_it < _tmp10__length1; path_it = path_it + 1) {
#line 377 "FileService.c"
			gchar* _tmp11_ = NULL;
			gchar* path = NULL;
#line 63 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			_tmp11_ = g_strdup (path_collection[path_it]);
#line 63 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
			path = _tmp11_;
#line 384 "FileService.c"
			{
				GFile* directory = NULL;
				const gchar* _tmp12_ = NULL;
				GFile* _tmp13_ = NULL;
				GFile* _tmp14_ = NULL;
				GFile* _tmp15_ = NULL;
				GFile* _tmp16_ = NULL;
				ContractorContractDirectory* contract_dir = NULL;
				GFile* _tmp17_ = NULL;
				ContractorContractDirectory* _tmp18_ = NULL;
				ContractorContractDirectory* _tmp19_ = NULL;
				GeeList* _tmp20_ = NULL;
				ContractorContractDirectory* _tmp21_ = NULL;
#line 64 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_tmp12_ = path;
#line 64 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_tmp13_ = g_file_new_for_path (_tmp12_);
#line 64 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_tmp14_ = _tmp13_;
#line 64 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_tmp15_ = g_file_get_child (_tmp14_, CONTRACTOR_FILE_SERVICE_CONTRACT_DATA_DIR_NAME);
#line 64 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_tmp16_ = _tmp15_;
#line 64 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_g_object_unref0 (_tmp14_);
#line 64 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				directory = _tmp16_;
#line 66 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_tmp17_ = directory;
#line 66 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_tmp18_ = contractor_contract_directory_new (_tmp17_);
#line 66 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				contract_dir = _tmp18_;
#line 67 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_tmp19_ = contract_dir;
#line 67 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				g_signal_connect_object (_tmp19_, "changed", (GCallback) _____lambda4__contractor_contract_directory_changed, self, 0);
#line 68 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_tmp20_ = self->priv->directories;
#line 68 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_tmp21_ = contract_dir;
#line 68 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				gee_collection_add ((GeeCollection*) _tmp20_, _tmp21_);
#line 63 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_g_object_unref0 (contract_dir);
#line 63 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_g_object_unref0 (directory);
#line 63 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
				_g_free0 (path);
#line 434 "FileService.c"
			}
		}
	}
#line 53 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	data_dir_paths = (_vala_array_free (data_dir_paths, data_dir_paths_length1, (GDestroyNotify) g_free), NULL);
#line 440 "FileService.c"
}


static void contractor_file_service_class_init (ContractorFileServiceClass * klass) {
#line 31 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	contractor_file_service_parent_class = g_type_class_peek_parent (klass);
#line 31 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	g_type_class_add_private (klass, sizeof (ContractorFileServicePrivate));
#line 31 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	G_OBJECT_CLASS (klass)->finalize = contractor_file_service_finalize;
#line 31 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	g_signal_new ("contract_files_changed", CONTRACTOR_TYPE_FILE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 453 "FileService.c"
}


static void contractor_file_service_instance_init (ContractorFileService * self) {
#line 31 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	self->priv = CONTRACTOR_FILE_SERVICE_GET_PRIVATE (self);
#line 460 "FileService.c"
}


static void contractor_file_service_finalize (GObject* obj) {
	ContractorFileService * self;
#line 31 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTRACTOR_TYPE_FILE_SERVICE, ContractorFileService);
#line 36 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	_g_object_unref0 (self->priv->directories);
#line 31 "/builddir/build/BUILD/contractor-0.3.2/src/FileService.vala"
	G_OBJECT_CLASS (contractor_file_service_parent_class)->finalize (obj);
#line 472 "FileService.c"
}


GType contractor_file_service_get_type (void) {
	static volatile gsize contractor_file_service_type_id__volatile = 0;
	if (g_once_init_enter (&contractor_file_service_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContractorFileServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contractor_file_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContractorFileService), 0, (GInstanceInitFunc) contractor_file_service_instance_init, NULL };
		GType contractor_file_service_type_id;
		contractor_file_service_type_id = g_type_register_static (G_TYPE_OBJECT, "ContractorFileService", &g_define_type_info, 0);
		g_once_init_leave (&contractor_file_service_type_id__volatile, contractor_file_service_type_id);
	}
	return contractor_file_service_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



